;*******************(C) COPYRIGHT 2020 Masses-Chip ******************************
;* File Name          : M8P634_Touch_M1_Lib_Data.INC
;* Author             : MASSES CHIP
;* Version            : V2.06
;* Date               : 2020/03/30
;********************************************************************************


;================================================================================ 
#include     M8P634_Touch_M1_Lib_CFG.INC 

;================================================================================ 
       

;================================================================================ 
;RAMʼַ޸ģ֤޸ĺ㹻ַ䵽ʹ
; RAM RTKLibGroup0 ʼַ ~ 0xff ʹ
#if  (TKLib_FILTER_LEVEL==0)
RTKLibGroup0 udata (0xff+1-13-11-2-6*TKLib_M1_OPENED_TK_AMOUNT-2*TKLib_TouchLowerPower*TKLib_M1_LP_OPENEDGROUP_AMOUNT)  
#endif
#if  (TKLib_FILTER_LEVEL==1)
RTKLibGroup0 udata (0xff+1-13-11-8-6*TKLib_M1_OPENED_TK_AMOUNT-2*TKLib_TouchLowerPower*TKLib_M1_LP_OPENEDGROUP_AMOUNT)  
#endif
#if  (TKLib_FILTER_LEVEL==2)
RTKLibGroup0 udata (0xff+1-13-11-16-6*TKLib_M1_OPENED_TK_AMOUNT-2*TKLib_TouchLowerPower*TKLib_M1_LP_OPENEDGROUP_AMOUNT)  
#endif
#if  (TKLib_FILTER_LEVEL>2)
RTKLibGroup0 udata (0xff+1-13-11-16-6*TKLib_M1_OPENED_TK_AMOUNT-2*TKLib_TouchLowerPower*TKLib_M1_LP_OPENEDGROUP_AMOUNT)  
#endif

;================================================================================ 
_RTkTemp0        res        1
_RTkTemp1        res        1 
_RTkTemp2        res        1 
_RTkTemp3        res        1 
_RTkTemp4        res        1 
_RTkTemp5        res        1
_RTkTemp6        res        1          
_RTkTemp7        res        1         
_RTkTemp8        res        1         
_RTkTemp9        res        1        
_RTkTemp10       res        1        
_RTkTemp11       res        1          
_RTkTemp12       res        1  

_RTkBuff0        res        1        
_RTkBuff1        res        1 
_RTkBuff2        res        1        
_RTkBuff3        res        1 
_RTkBuff4        res        1  
_RTkBuff5        res        1  

#if  TKLib_M1_OPENED_TK_AMOUNT
_RTkGBuff0       res        2*TKLib_M1_OPENED_TK_AMOUNT          
_RTkGBuff1       res        2*TKLib_M1_OPENED_TK_AMOUNT         
_RTkGBuff2       res        1*TKLib_M1_OPENED_TK_AMOUNT
_RTkGBuff3       res        1*TKLib_M1_OPENED_TK_AMOUNT
#if  (TKLib_FILTER_LEVEL==0)
_RTkGBuff4       res        2  
#endif
#if  (TKLib_FILTER_LEVEL==1)
_RTkGBuff4       res        8  
#endif
#if  (TKLib_FILTER_LEVEL==2)
_RTkGBuff4       res        16  
#endif
#if  (TKLib_FILTER_LEVEL>2)
_RTkGBuff4       res        16  
#endif      
#endif
 
#if TKLib_TouchLowerPower 
#if  TKLib_M1_LP_OPENEDGROUP_AMOUNT
_RTkLPGBuff0     res        2*TKLib_M1_LP_OPENEDGROUP_AMOUNT             
#endif
#endif
 
_RChannelEnL     res        1       
_RChannelEnH     res        1       
_RKeyOnFlgL      res        1        
_RKeyOnFlgH      res        1 
_RTkBitFlag      res        1  

;================================================================================  
; ûʹ
;================================================================================ 
#if TKLib_TouchLowerPower
TAB_TOUCH_TKLP_CFG_DATA:
 org    (0x0FEF+1-1-7-TKLib_M1_OPENED_TK_AMOUNT-5)  
 
TAB_TOUCH_TKLP_OPENEDGROUP_MASK:
 DW     ((TKLib_M1_LP_TKLPGROUP_MASK&0xff)+((TKLib_Sleep_F_THRESHOLD&0xff)<<8))
TAB_TOUCH_TKLP_MASK_DATA: 
 DW     TKLib_M1_TKLPGroup0_MASK
 DW     TKLib_M1_TKLPGroup1_MASK
 DW     TKLib_M1_TKLPGroup2_MASK 
 DW     TKLib_M1_TKLPGroup3_MASK 
#endif

TAB_TOUCH_CFG_DATA:
 org    (0x0FEF+1-1-7-TKLib_M1_OPENED_TK_AMOUNT)  
TAB_TOUCH_TK_EN_MASK_DATA:
 DW     TKLib_M1_TK_EN_MASK
 
TAB_TOUCH_TKCKS_And_Scan_SW_DATA: 
 DW     (((TKLib_M1_TKCKS&0x03)<<4)+((TKLib_M1_OPENED_TK_AMOUNT&0x1F)<<8))
 
TAB_TOUCH_NUM_DATA:  
 DW     ((TKLib_LONG_TOUCH_TIME&0x0F)+((TKLib_FILTER_LEVEL&0x03)<<4) +((TKLib_TOUCH_NUM&0x1F)<<8)+((TKLib_Multi_TOUCH_RST&0x01)<<15))
 
TAB_TOUCH_CONFIRM_TIME_DATA: 
 DW     ((TKLib_EFFECTIVE_TOUCH_TIME&0x0F)+((TKLib_INVALID_TOUCH_TIME&0x0F)<<4) +((TKLib_Debounce_TIME&0xFF)<<8))

TAB_TOUCH_Calibration_TIME_DATA:
 DW     (((TKLib_Down_Calibration_Rate&0x07)<<0)+((TKLib_Up_Calibration_Rate&0x07)<<8))

TAB_TOUCH_STEP_DATA:
 DW     ((0x03&0xff)+((0x03&0xff)<<8))

TAB_TOUCH_NOISE_DATA:
 DW     ((0x05&0xff)+((0x07&0xff)<<8))

TAB_TOUCH_FN_DATA:
#if EnTk16  
 DW     ((0&0xff)+((TKLib_TK16_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk17 
 DW     ((0&0xff)+((TKLib_TK17_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk18  
 DW     ((0&0xff)+((TKLib_TK18_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk19  
 DW     ((0&0xff)+((TKLib_TK19_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk20  
 DW     ((0&0xff)+((TKLib_TK20_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk21  
 DW     ((0&0xff)+((TKLib_TK21_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk22  
 DW     ((0&0xff)+((TKLib_TK22_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk23  
 DW     ((0&0xff)+((TKLib_TK23_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk24  
 DW     ((0&0xff)+((TKLib_TK24_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk25  
 DW     ((0&0xff)+((TKLib_TK25_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk26  
 DW     ((0&0xff)+((TKLib_TK26_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk27  
 DW     ((0&0xff)+((TKLib_TK27_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk28  
 DW     ((0&0xff)+((TKLib_TK28_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk29  
 DW     ((0&0xff)+((TKLib_TK29_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk30  
 DW     ((0&0xff)+((TKLib_TK30_F_THRESHOLD&0xff)<<8))
#endif

#if EnTk31  
 DW     ((0&0xff)+((TKLib_TK31_F_THRESHOLD&0xff)<<8))
#endif
 
 DW     (0x0309) 
;================================================================================         
 ; RAM
 GLOBAL _RTkTemp0   
 GLOBAL _RTkTemp1   
 GLOBAL _RTkTemp2    
 GLOBAL _RTkTemp3   
 GLOBAL _RTkTemp4  
 GLOBAL _RTkTemp5      
 GLOBAL _RTkTemp6    
 GLOBAL _RTkTemp7    
 GLOBAL _RTkTemp8    
 GLOBAL _RTkTemp9    
 GLOBAL _RTkTemp10   
 GLOBAL _RTkTemp11     
 GLOBAL _RTkTemp12 
 
 GLOBAL _RTkBitFlag     
 GLOBAL _RKeyOnFlgL   
 GLOBAL _RKeyOnFlgH   
 GLOBAL _RChannelEnL     
 GLOBAL _RChannelEnH 

 GLOBAL _RTkBuff0     
 GLOBAL _RTkBuff1  
 GLOBAL _RTkBuff2     
 GLOBAL _RTkBuff3 
 GLOBAL _RTkBuff4 
 GLOBAL _RTkBuff5
  
 GLOBAL _RTkGBuff0     
 GLOBAL _RTkGBuff1    
 GLOBAL _RTkGBuff2     
 GLOBAL _RTkGBuff3 
 GLOBAL _RTkGBuff4
 
 ; CODE
 GLOBAL TAB_TOUCH_TK_EN_MASK_DATA          
 GLOBAL TAB_TOUCH_TKCKS_And_Scan_SW_DATA           
 GLOBAL TAB_TOUCH_CONFIRM_TIME_DATA   
 GLOBAL TAB_TOUCH_NUM_DATA
 GLOBAL TAB_TOUCH_Calibration_TIME_DATA
 GLOBAL TAB_TOUCH_STEP_DATA 
 GLOBAL TAB_TOUCH_NOISE_DATA 
 GLOBAL TAB_TOUCH_FN_DATA 
 
#if TKLib_TouchLowerPower 
 ; RAM 
 GLOBAL _RTkLPGBuff0     

 ; CODE
 GLOBAL TAB_TOUCH_TKLP_OPENEDGROUP_MASK          
 GLOBAL TAB_TOUCH_TKLP_MASK_DATA  
#endif
 
;================================================================================
#if 1
;================================================================================
#if EnTk16
    MESSG "    TK16: Enable"  
#endif
#if EnTk17
    MESSG "    TK17: Enable"  
#endif
#if EnTk18
    MESSG "    TK18: Enable"  
#endif
#if EnTk19
    MESSG "    TK19: Enable"  
#endif
#if EnTk20
    MESSG "    TK20: Enable"  
#endif
#if EnTk21
    MESSG "    TK21: Enable"  
#endif
#if EnTk22
    MESSG "    TK22: Enable"  
#endif
#if EnTk23
    MESSG "    TK23: Enable"  
#endif
#if EnTk24
    MESSG "    TK24: Enable"  
#endif
#if EnTk25
    MESSG "    TK25: Enable"  
#endif
#if EnTk26
    MESSG "    TK26: Enable"  
#endif
#if EnTk27
    MESSG "    TK27: Enable"  
#endif
#if EnTk28
    MESSG "    TK28: Enable"  
#endif
#if EnTk29
    MESSG "    TK29: Enable"  
#endif
#if EnTk30
    MESSG "    TK30: Enable"  
#endif
#if EnTk31
    MESSG "    TK31: Enable"  
#endif

;================================================================================
#if (TKLib_M1_OPENED_TK_AMOUNT == 0)
    Error "    No channel is enabled,Please reconfigure EnTk16~EnTk31"  
#endif	

;================================================================================
;CDC Clock
#if (TKLib_M1_TKCKS == 0)
    MESSG "    CDC1 Clock: Fosc/4"  
#endif
#if (TKLib_M1_TKCKS == 1)
    MESSG "    CDC1 Clock: Fosc/8"  
#endif
#if (TKLib_M1_TKCKS == 2)
    MESSG "    CDC1 Clock: Fosc/16"  
#endif
#if (TKLib_M1_TKCKS == 3)
    MESSG "    CDC1 Clock: Fosc/32" 
#endif

;================================================================================
#if (TKLib_TOUCH_NUM == 0)
    Error "    Error: Please setting TKLib_TOUCH_NUM > 0"  
#endif

;================================================================================
#if (TKLib_Debounce_TIME == 0)
    Error "    Error: Please setting TKLib_Debounce_TIME > 0"  
#endif
#if (TKLib_Debounce_TIME > 255)
    Error "    Error: Please setting TKLib_Debounce_TIME <= 255"  
#endif

;================================================================================
#if (TKLib_LONG_TOUCH_TIME == 0)
    MESSG "    ΰʱ书ܣ뿪־һֱλ " 
#endif
#if (TKLib_LONG_TOUCH_TIME == 1)
    Error "    ֹ " 
#endif

#if (TKLib_LONG_TOUCH_TIME > 15)
    Error "    Error: Please setting TKLib_LONG_TOUCH_TIME <= 15"  
#endif

;================================================================================
#if (TKLib_Multi_TOUCH_RST > 1)
    Error "    Error: Please setting TKLib_Multi_TOUCH_RST  {0,1}  "  
#endif

;================================================================================
#if (TKLib_Up_Calibration_Rate < 1)
    Error "    Error: Please setting TKLib_Up_Calibration_Rate >= 1" 
#endif
#if (TKLib_Up_Calibration_Rate > 7)
    Error "    Error: Please setting TKLib_Up_Calibration_Rate <= 7"  
#endif

#if (TKLib_Down_Calibration_Rate < 1)
    Error "    Error: Please setting TKLib_Down_Calibration_Rate >= 1" 
#endif
#if (TKLib_Down_Calibration_Rate > 7)
    Error "    Error: Please setting TKLib_Down_Calibration_Rate <= 7"  
#endif

;================================================================================
#if (TKLib_CaliBaseTime < 1)
    Error "    Error: Please setting TKLib_CaliBaseTime >= 1" 
#endif
#if (TKLib_CaliBaseTime > 254)
    Error "    Error: Please setting TKLib_CaliBaseTime <= 254"  
#endif

#if (TKLib_LongKeyBaseTime < 1)
    Error "    Error: Please setting TKLib_LongKeyBaseTime >= 1" 
#endif
#if (TKLib_LongKeyBaseTime > 254)
    Error "    Error: Please setting TKLib_LongKeyBaseTime <= 254"  
#endif

;================================================================================
#if (TKLib_EFFECTIVE_TOUCH_TIME == 0)
    Error "    Error: Please setting TKLib_EFFECTIVE_TOUCH_TIME > 0"  
#endif
#if (TKLib_EFFECTIVE_TOUCH_TIME > 15)
    Error "    Error: Please setting TKLib_EFFECTIVE_TOUCH_TIME <= 15"  
#endif

;================================================================================
#if (TKLib_INVALID_TOUCH_TIME == 0)
    Error "    Error: Please setting TKLib_INVALID_TOUCH_TIME > 0"  
#endif
#if (TKLib_INVALID_TOUCH_TIME > 15)
    Error "    Error: Please setting TKLib_INVALID_TOUCH_TIME <= 15"  
#endif

;================================================================================
#if (TKLib_FILTER_LEVEL == 0)
    MESSG "    ˲ȼͨ " 
#endif
#if (TKLib_FILTER_LEVEL == 1)
    MESSG "    ˲ȼ " 
#endif
#if (TKLib_FILTER_LEVEL == 2)
    MESSG "    ˲ȼ " 
#endif
#if (TKLib_FILTER_LEVEL > 2)    
    Error "    Error: Please setting TKLib_FILTER_LEVEL <= 2"  
#endif
   
;================================================================================
#if (TKLib_TK16_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK16_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK17_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK17_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK18_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK18_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK19_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK19_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK20_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK20_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK21_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK21_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK22_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK22_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK23_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK23_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK24_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK24_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK25_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK25_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK26_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK26_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK27_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK27_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK28_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK28_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK29_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK29_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK30_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK30_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK31_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK31_F_THRESHOLD <= 255"  
#endif

;================================================================================
#if (TKLib_TK16_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK16_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK17_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK17_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK18_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK18_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK19_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK19_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK20_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK20_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK21_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK21_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK22_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK22_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK23_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK23_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK24_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK24_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK25_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK25_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK26_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK26_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK27_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK27_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK28_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK28_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK29_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK29_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK30_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK30_F_THRESHOLD >= 9"
#endif
#if (TKLib_TK31_F_THRESHOLD <9)
    Error "    Error: Please setting TKLib_TK31_F_THRESHOLD >= 9"
#endif

;================================================================================
#if TKLib_TouchLowerPower
    MESSG "    ͹ģʽѿ " 
#else
    MESSG "    ͹ģʽδ "	
#endif
#if (TKLib_TouchLowerPower>1)
    MESSG "    ͹ģʽôTKLib_TouchLowerPower  {0,1} "	
#endif
;================================================================================
;--------------------------------------------------------------------------------
#if TKLib_TouchLowerPower
;--------------------------------------------------------------------------------
#if TKLPGroup0
#if (TKLib_M1_TKLPGroup0_MASK==0)
    Error "    Error: Please setting TKLib_M0_TKLPGroup0_MASK != 0"
#endif
#endif

#if TKLPGroup1
#if (TKLib_M1_TKLPGroup1_MASK==0)
    Error "    Error: Please setting TKLib_M0_TKLPGroup1_MASK != 0"
#endif
#endif

#if TKLPGroup2
#if (TKLib_M1_TKLPGroup2_MASK==0)
    Error "    Error: Please setting TKLib_M0_TKLPGroup2_MASK != 0"
#endif
#endif

#if TKLPGroup3
#if (TKLib_M1_TKLPGroup2_MASK==0)
    Error "    Error: Please setting TKLib_M0_TKLPGroup2_MASK != 0"
#endif
#endif
;--------------------------------------------------------------------------------
#if (TKLib_M1_OPENED_TK_AMOUNT == 0)
    Error "    No Group is enabled,Please reconfigure TKLPGroup0~TKLPGroup3"  
#endif
	
;--------------------------------------------------------------------------------
#if (TKLib_Sleep_F_THRESHOLD <3)
    Error "    Error: Please setting TKLib_Sleep_F_THRESHOLD >= 3"
#endif

;--------------------------------------------------------------------------------
#if TKLPLib_RCOUT_EN
    MESSG "    ͹ģʽ¸˿ڣʹ " 
#else
    MESSG "    ͹ģʽ¸˿ڣʹ "	
#endif

;--------------------------------------------------------------------------------
#endif
;--------------------------------------------------------------------------------

;================================================================================
#endif
 
 
 
;================================================================================  

;*********************************END OF FILE************************************
                                 